2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
11 source /a
/bin
/distro-setup
/path-add-function
13 # add this with absolute paths as needed for better security
14 #path-add --end /path/to/node_modules/.bin
16 # pip3 --user things go here:
17 path-add
--end ~
/.local
/bin
18 path-add
--ifexists --end /a
/work
/libremanage
19 path-add
--ifexists --end /a
/opt
/adt-bundle
*/tools
/a
/opt
/adt-bundle
*/platform-tools
20 path-add
--ifexists --end /a
/opt
/scancode-toolkit-3.10.
28 SL_SSH_ARGS
="-F $HOME/.ssh/confighome"
35 # generated instead of dynamic for the benefit of shellcheck
36 #for x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do echo source $x ; done
37 source /a
/bin
/distro-functions
/src
/identify-distros
38 source /a
/bin
/log-quiet
/logq-function
39 # for x in /a/bin/bash_unpublished/source-!(.#*); do echo source $x; done
40 source /a
/bin
/bash_unpublished
/source-semi-priv
41 source /a
/bin
/bash_unpublished
/source-state
43 source /a
/bin
/log-quiet
/logq-function
44 if [[ -s /a
/opt
/alacritty
/extra
/completions
/alacritty.bash
]]; then
45 source /a
/opt
/alacritty
/extra
/completions
/alacritty.bash
54 sed '/^ *IdentityFile/d' ~
/.ssh
/config
>$d/config
55 s
command ssh -F $d/config
-i /q
/root
/h
"$@"
61 sed '/^ *IdentityFile/d' ~
/.ssh
/config
>$d/config
62 s rsync
-e "ssh -F $d/config -i /q/root/h" "$@"
70 if [[ $arg == [89]0Etiona
* ]]; then
72 rtime
=${arg#*Etiona} # remote time
73 if [[ ! $rtime ]]; then
76 dir
=/a
/opt
/emacs-trisquel
${v}-nox/.iank
77 ltime
=$
(stat
-c%Y
$dir/e
/e
/.emacs.d
/init.el
)
78 if (( ltime
> rtime
)); then
79 m rsync
-rptL --delete --filter=". /b/ds/sl/rsync-filter" $dir "$remote":/home
/iank
85 local f
=/home
/iank
/.emacs.d
/init.el
86 sl
--sl-test-cmd ". /etc/os-release ; printf %s \${VERSION//[^a-zA-Z0-9]/}; test -e $f && stat -c%Y $f" --sl-test-hook slemacs
"$@"
90 # Run this manually after .emacs.d changes. Otherwise, to check if
91 # files changed with find takes 90ms. sl normally only adds 25ms. We
92 # could cut it down to 10ms if we put things on a btrfs filesystem and
93 # looked for changes there, or used some inotify thing, but that seems
95 egh
() { # emacs gnuhope
96 RSYNC_RSH
=ssh m rsync
-rptL --delete --filter=". /b/ds/sl/rsync-filter" /a
/opt
/emacs-trisquel9-nox
/.iank lists2d.fsf.org
:.ianktrisquel_9
97 RSYNC_RSH
=ssh m rsync
-rptL --delete --filter=". /b/ds/sl/rsync-filter" /a
/opt
/emacs-trisquel8-nox
/.iank lists2d.fsf.org
:/home
/iank
100 local shell
="bash -s"
101 if [[ $HOSTNAME != kw
]]; then
102 shell
="ssh kw.office.fsf.org"
106 sudo mkdir /root/.ianktrisquel_9
107 sudo rsync -rptL --delete --filter=". /b/ds/sl/rsync-filter" /a/opt/emacs-trisquel9-nox/.iank /root/.ianktrisquel_9
108 rsync -rptL --delete --filter=". /b/ds/sl/rsync-filter" /a/opt/emacs-trisquel8-nox/.iank /home/iank
112 # usage mkschroot [-] distro codename packages
113 # - means no piping in of sources.list
116 while [[ $1 == -* ]]; do
118 -f) force
=true
; shift ;;
121 if [[ ! -s $sources ]]; then
122 echo mkschroot
: error
: sources
file $sources does not exist or is empty
133 repo
=http
://mirror.fsf.org
/trisquel
/
136 repo
=http
://archive.ubuntu.com
/ubuntu
/
139 repo
=http
://deb.debian.org
/debian
/
145 if ! $force && schroot
-l |
grep -xFq chroot
:$n; then
146 echo "$0: $n schroot already installed, skipping"
151 sd
/etc
/schroot
/chroot.d
/$n.conf
<<EOF
157 preserve-environment=true
161 if [[ ! -e $d/bin
]]; then
163 # resolvconf otherwise schroot fails with
164 # cp: not writing through dangling symlink '/var/run/schroot/mount/flidas-7a2362e0-81b3-4848-92c1-610203ef5976/etc/resolv.conf'
165 sudo debootstrap
--exclude=resolvconf
$n $d $repo
167 if [[ $sources ]]; then
168 sudo
install -m 644 $sources $d/etc
/apt
/sources.list
170 sudo chroot
$d apt-get update
171 sudo DEBIAN_FRONTEND
=noninteractive chroot
$d apt-get
-y dist-upgrade
--purge --auto-remove
172 sudo DEBIAN_FRONTEND
=noninteractive schroot
-c $n -- apt-get
install --allow-unauthenticated -y ${apps[@]}
173 sudo
cp -P {,$d}/etc
/localtime
177 # note: this is incomplete and untested.
178 # https://wiki.archlinux.org/index.php/Install_Arch_Linux_from_existing_Linux#Creating_a_chroot
181 mirror
=https
://mirrors.edge.kernel.org
/archlinux
/iso
/latest
/
182 tarball
=$
(curl
-s $mirror |
sed -nr 's/.*"(archlinux-bootstrap-.*-x86_64.tar.gz)".*/\1/p')
183 wget
-O /tmp
/arch.
tar.gz https
://mirrors.edge.kernel.org
/archlinux
/iso
/latest
/$tarball
184 s mkdir
-p /nocow
/schroot
/arch
185 cd _
/nocow
/schroot
/arch
186 s
sed -i '/## United States/,/^$/s,^#,,' etc
/pacman.d
/mirrorlist
187 # error: could not determine cachedir mount point /var/cache/pacman/pkg
188 s
sed -i /^CheckSpace
/d etc
/pacman.conf
189 chroot .
/bin
/bash
-s <<'EOF'
191 pacman-key --populate archlinux
194 # example of building an aur package:
195 # pacman -Sy base-devel wget
197 # f=$target/etc/sudoers
198 # line='iank ALL=(ALL) NOPASSWD: ALL'
199 # if [[ ! -e $f ]] || ! grep -xF "$line" $f; then
203 # wget https://aur.archlinux.org/cgit/aur.git/snapshot/anbox-image-gapps.tar.gz
204 # tar xzf anbox-image-gapps.tar.gz
205 # cd anbox-image-gapps
210 # clock back in to timetrack from last entry
212 sqlite3
/p
/.timetrap.db
"update entries set end = NULL where id = (select max(id) from entries);"
216 # s sshfs bu@$host:/bu/home/md /bu/mnt -o reconnect,ServerAliveInterval=20,ServerAliveCountMax=30 -o allow_other
219 enn
-M $
(exiqgrep
-i)
222 enn
-M $
(exiqgrep
-i|h1
)
227 /a
/f
/gnulib
/build-aux
/gnupload
"$@"
233 f
=(/p
/c
/firefox
*/compatibility.ini
)
234 if (( ${#f[@]} )); then
240 if shopt nullglob
>/dev
/null
; then
254 s checkrestart
-b /a
/bin
/ds
/checkrestart-blacklist
-pv
257 cp-blocked-domains-to-brains
() {
258 cp /a
/f
/ans
/roles
/exim
/files
/mx
/simple
/etc
/exim
4/bad-sender_domains
/a
/f
/brains
/sysadmin
/kb
/blocked_email_domains.mdwn
260 cp-blocked-domains-to-ansible
() {
261 cp /a
/f
/brains
/sysadmin
/kb
/blocked_email_domains.mdwn
/a
/f
/ans
/roles
/exim
/files
/mx
/simple
/etc
/exim
4/bad-sender_domains
266 # crashes on adding new cards in t9
267 schroot
-c buster
-- anki
272 hrcat
/m
/md
/alerts
/{cur
,new
}/*
275 ssh bk.b8.nz
"shopt -s nullglob; hrcat /m/md/INBOX/new/* /m/md/INBOX/cur/*"
279 rm -f /m
/md
/alerts
/{cur
,new
}/*
281 ssh bk.b8.nz
"shopt -s nullglob; rm -f /m/md/INBOX/new/* /m/md/INBOX/cur/*"
286 # pushd in case current directory has an ansible.cfg file
287 pushd /a
/xans
>/dev
/null
288 ansible-playbook
-v -l ${1:- $(hostname -f)} site.yml
292 pushd /a
/work
/ans
>/dev
/null
293 time ansible-playbook
-v -i inventory adhoc.yml
"$@"
297 pushd /a
/bin
/distro-setup
/a
>/dev
/null
298 ansible-playbook site.yml
"$@"
303 # googling android emulator libGL error: failed to load driver: r600
304 # lead to http://stackoverflow.com/a/36625175/14456
305 export ANDROID_EMULATOR_USE_SYSTEM_LIBS
=1
306 /a
/opt
/android-studio
/bin
/studio.sh
"$@" &r
;
309 # note, to check for glue records
310 # First, find some the .org nameservers:
311 # dig +trace iankelling.org
313 # dig ns1.iankelling.org @b0.org.afilias-nst.org.
315 # Now, compare for a domain that does have glue records setup (note the A
316 # and AAAA records in ADDITIONAL SECTION, those are glue records like the
317 # one I'm asking for):
319 # $ dig ns1.gnu.org @b0.org.afilias-nst.org.
321 # todo: make sm pull/push use systemd instead of the journal cat command
322 bbk
() { # btrbk wrapper
326 systemctl is-active btrbk.timer || active
=false
330 if [[ $
(systemctl is-active btrbk.service ||
:) != inactive
]]; then
331 echo "cron btrbk is already running"
332 if $active; then ser start btrbk.timer
; fi
337 # todo: consider changing this to srun and having the args come
338 # from a file like /etc/default/btrbk, like is done in exim
339 s jrun btrbk-run
"$@"
342 echo bbk
: WARNING
: btrbk.timer not restarted due to failure
344 ser start btrbk.timer
351 fai-monitor | pee
cat "fai-monitor-gui -"
354 bfg
() { java
-jar /a
/opt
/bfg-1.12
.14.jar
"$@"; }
357 xclock
-digital -update 1 -face 'arial black-80:bold'
360 nnn
() { /a
/opt
/nnn
-H "$@"; }
363 # duplicated somewhat below.
364 jrun
() { # journal run. run args, log to journal, tail and grep the journal.
365 # Note, an alternative without systemd would be something like ts.
366 # Note, I tried using systemd-cat, but this seems obviously better,
367 # and that seemed to have a problem exiting during a systemctl daemon-reload
368 local cmd_name jr_pid s
372 if [[ $cmd != /* ]]; then
375 journalctl
-qn2 -f -u "$cmd_name" &
376 # Guess of time needed to avoid missing initial lines.
377 # .5 was not reliable. 1 was not reliable. 2 was not reliable
379 # We kill this in prompt-command for the case that we ctrl-c the
380 # systemd-cat. i dont know any way to trap ctrl-c and still run the
381 # normal action for it. There might be a way, unsure.
383 # note, we could have a version that does system --user, but if for example
384 # it does sudo ssh, that will leave a process around that we can't kill
385 # and it will leave the unit hanging around in a failed state needing manual
386 # killing of the process.
387 m s systemd-run
--uid $
(id
-u) --gid $
(id
-g) \
388 -E SSH_AUTH_SOCK
=/run
/openssh_agent \
389 --unit "$cmd_name" --wait --collect "$cmd" "${@:2}" || ret
=$?
390 # This justs lets the journal output its last line
391 # before the prompt comes up.
393 kill $jr_pid &>/dev
/null ||
:
397 # service run, and watch the output
402 journalctl
-qn2 -f -u $unit &
403 systemctl start
$unit
405 kill $jr_pid &>/dev
/null ||
:
414 keyhash
=$
(s ssh-keygen
-lf /root
/.ssh
/home |
awk '{print $2}')
415 tmp
=$
(s ssh-add
-l |
awk '$2 == "'$keyhash'"')
416 if [[ ! $tmp ]]; then
417 s ssh-add
/root
/.ssh
/home
420 s jrun switch-mail-host
"$@"
424 # shellcheck disable=SC2120
426 # note, i had --delete-excluded, but that deletes all files in --exclude-from on
427 # the remote site, which doesn't make sense, so not sure why i had it.
429 p
=(/a
/opt
/{emacs-debian11
{,-nox},mu
,emacs
} /a
/bin
/a
/exe
/a
/h
/a
/c
/p
/c
/machine_specific
/vps
{,.hosts
})
430 a
="-ahviSAXPH --specials --devices --delete --relative --exclude-from=/p/c/li-rsync-excludes"
432 for h
in li je bk
; do
433 m s rsync
"$@" $a ${p[@]} /p
/c
/machine_specific
/$h root@
$h.b8.nz
:/ || ret
=$?
434 # only li is debian11
435 p
[0]=/a
/opt
/emacs-ubuntu20.04
436 p
[1]=/a
/opt
/emacs-ubuntu20.04
-nox
438 m s rsync
"$@" -ahviSAXPH root@li.b8.nz
:/a
/h
/proposed-comments
/ /a
/h
/proposed-comments || ret
=$?
441 bkpush
() { # no emacs. for running faster.
442 p
=(/a
/bin
/a
/exe
/a
/h
/a
/c
/p
/c
/machine_specific
/vps
{,.hosts
})
443 a
="-ahviSAXPH --specials --devices --delete --relative --exclude-from=/p/c/li-rsync-excludes"
445 m rsync
"$@" $a ${p[@]} /p
/c
/machine_specific
/bk root@bk.b8.nz
:/ || ret
=$?
448 jepush
() { # no emacs. for running faster.
449 p
=(/a
/bin
/a
/exe
/a
/h
/a
/c
/p
/c
/machine_specific
/vps
{,.hosts
})
450 a
="-ahviSAXPH --specials --devices --delete --relative --exclude-from=/p/c/li-rsync-excludes"
452 m rsync
"$@" $a ${p[@]} /p
/c
/machine_specific
/je root@je.b8.nz
:/ || ret
=$?
457 dsign iankelling.org expertpathologyreview.com zroe.org amnimal.ninja
467 dsign iankelling.org expertpathologyreview.com zroe.org amnimal.ninja
483 local f
=/var
/lib
/bind
/db.b8.nz
486 sudo
install -m 644 -o bind -g bind /p
/c
/machine_specific
/vps
/bind-initial
/db.b8.nz
$f
490 # keys generated like this
491 # because of https://ftp.isc.org/isc/dnssec-guide/dnssec-guide.pdf
492 # https://blog.apnic.net/2019/05/23/how-to-deploying-dnssec-with-bind-and-ubuntu-server/
494 # key length is longer than that guide because
495 # we are using those at fsf and when old key lengths
496 # become insecure, I want some extra time to update.
500 dnssec-keygen
-a RSASHA256
-b 2048 $zone
501 dnssec-keygen
-f KSK
-a RSASHA256
-b 4096 $zone
502 for f
in K
$zone.
*.key
; do
503 # eg Kb8.nz.+008+47995.key tag=47995
504 # in dnsimple, you add the long string from this.
505 # in gandi, you add the long string from the .key file,
506 # then see that the digest matches the ds.
507 echo "tag is the number after DS"
508 dnssec-dsfromkey
-a SHA-256
$f
510 # For b8.nz, we let bind read the keys and sign, and
511 # right now they have root ownership, so let them
516 # create .signed file
517 # note: full paths probably not needed.
520 local zone
=${arg#db.}
521 local dir
=/p
/c
/machine_specific
/vps
/filesystem
/var
/lib
/bind
522 dnssec-signzone
-S -e +31536000 -o $zone -K $dir -d $dir $dir/db.
$zone
527 #### begin bitcoin related things
529 local f
=/etc
/bitcoin
/bitcoin.conf
530 # importprivkey will timeout if using the default of 15 mins.
531 # upped it to 1 hour.
532 bitcoin-cli
-rpcclienttimeout=60000 -$
(s
grep rpcuser
= $f) -$
(s
grep rpcpassword
= $f) "$@"
534 btcusd
() { # $1 btc in usd
536 price
="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
537 printf "$%s\n" "$price"
539 printf "$%.2f\n" "$(echo "scale
=4; $price * $1"| bc -l)"
542 usdbtc
() { # $1 usd in btc
544 price
="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
545 printf "$%s\n" "$price"
547 # 100 mil satoshi / btc. 8 digits after the 1.
548 printf "%.8f btc\n" "$(echo "scale
=10; $1 / $price "| bc -l)"
551 satoshi
() { # $1 satoshi in usd
553 price
="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
554 price
=$
(echo "scale=10; $price * 0.00000001"|
bc -l)
555 printf "$%f\n" "$price"
557 printf "$%.2f\n" "$(echo "scale
=10; $price * $1"| bc -l)"
560 #### end bitcoin related things
564 cbfstool
() { /a
/opt
/coreboot
/build
/cbfstool
"$@"; }
570 cp /a
/bin
/data
/COPYING
"$@"
572 cp /a
/bin
/data
/COPYING .
579 cp /a
/bin
/data
/LICENSE
"$@"
581 cp /a
/bin
/data
/LICENSE .
586 if type -p chromium
&>/dev
/null
; then
590 cmd
="schroot -c bullseye chromium"
591 CHROMIUM_FLAGS
='--enable-remote-extensions' $cmd &r
597 # pipe to this, or just type like a shell
600 tee >(ssh frodo.b8.nz
) >(ssh x2
) >(ssh tp.b8.nz
) >(ssh kw
) >(ssh tp.b8.nz
)
604 for host in x2 kw tp.b8.nz x3.b8.nz frodo.b8.nz
; do
610 debian_pick_mirror
() {
611 # netselect-apt finds a fast mirror.
612 # but we need to replace the mirrors ourselves,
613 # because it doesnt do that. best it can do is
614 # output a basic sources file
615 # here we get the server it found, get the main server we use
616 # then substitute all instances of one for the other in the sources file
617 # and backup original to /etc/apt/sources.list-original.
618 # this is idempotent. the only way to identify debian sources is to
619 # note the original server, so we put it in a comment so we can
622 file=$
(mktemp
-d)/f
# safe way to get file name without creating one
623 sudo netselect-apt
-o "$file" ||
return 1
624 url
=$
(grep ^
\\w
$file |
head -n1 |
awk '{print $2}')
625 sudo
cp -f /etc
/apt
/sources.list
/etc
/apt
/sources.list-original
626 sudo
sed -ri "/http.us.debian.org/ s@( *[^ #]+ +)[^ ]+([^#]+).*@\1$url\2# http.us.debian.org@" /etc
/apt
/sources.list
630 digdiff @ns
{1,2}.iankelling.org
"$@"
634 "$@" |
& ts ||
return $?
644 /b
/ds
/distro-begin |
& ts ||
return $?
645 /b
/ds
/distro-end |
& ts ||
return $?
651 /b
/ds
/distro-begin |
& ts ||
return $?
657 /b
/ds
/distro-end |
& ts ||
return $?
670 envload
() { # load environment from a previous: export > file
671 local file=${1:-$HOME/.${USER}_env}
672 eval "$(export | sed 's/^declare -x/export -n/')"
673 while IFS
= read -r line
; do
674 # declare -x makes variables local to a function
675 eval ${line/#declare -x/export}
679 failfunc
() { asdf a b c
; }
680 failfunc2
() { failfunc d e f
; }
682 # one that comes with distros is too old for newer devices
684 /a
/opt
/android-platform-tools
/fastboot
"$@";
687 kdecd
() { /usr
/lib
/x86_64-linux-gnu
/libexec
/kdeconnectd
; }
689 # List of apps to install/update
690 # Create from existing manually installed apps by doing
692 # fdroidcl search -i, then manually removing
693 # automatically installed/preinstalled apps
696 # # my attempt at recovering from boot loop:
697 # # in that case, boot to recovery (volume up, home button, power, let go of power after samsun logo)
699 # mount /dev/block/mmcblk0p12 /data
701 # find -iname '*appname*'
703 # usually good enough to just rm -rf /data/app/APPNAME
706 # # causes replicant to crash
707 # org.quantumbadger.redreader
708 # org.kde.kdeconnect_tp
710 # not broke, but wont work without gps
711 #com.zoffcc.applications.zanavi
712 # not broke, but not using atm
713 #com.nutomic.syncthingandroid
714 # # doesn\'t work on replicant
715 #net.sourceforge.opencamera
718 net.mullvad.mullvadvpn
720 io.github.subhamtyagi.lastlauncher
722 com.biglybt.android.client
723 de.marmaro.krt.ffupdater
724 me.ccrama.redditslide
725 org.fedorahosted.freeotp
727 com.alaskalinuxuser.justnotes
728 com.artifex.mupdf.viewer.app
729 com.danielkim.soundrecorder
732 com.jmstudios.redmoon
734 org.kde.kdeconnect_tp
737 cz.martykan.forecastie
740 de.marmaro.krt.ffupdater
741 eu.siacs.conversations
743 im.vector.alpha
# riot
745 me.tripsit.tripmobile
747 net.minetest.minetest
752 org.smssecure.smssecure
754 sh.
ftp.rocketninelabs.meditationassistant.opensource
756 # https://forum.xda-developers.com/android/software-hacking/wip-selinux-capable-superuser-t3216394
761 local -A installed updated
763 # tried putting this in go buildscript cronjob,
764 # but it failed with undefined: os.UserCacheDir. I expect its due to
765 # an environment variable missing, but its easier just to stick it here.
766 m go get
-u mvdan.cc
/fdroidcl ||
return 1
768 if fdroidcl search
-u |
grep ^org.fdroid.fdroid
; then
769 fdroidcl
install org.fdroid.fdroid
773 for p
in $
(fdroidcl search
-i|
grep -o "^\S\+"); do
776 for p
in $
(fdroidcl search
-u|
grep -o "^\S\+"); do
779 for p
in ${fdroid_pkgs[@]}; do
780 if ! ${installed[$p]:-false}; then
781 m fdroidcl
install $p
782 # sleeps are just me being paranoid since replicant has a history of crashing when certain apps are installed
786 for p
in ${!installed[@]}; do
787 if ! ${updated[$p]:-true}; then
788 m fdroidcl
install $p
794 firefox-default-profile
() {
795 key
=Default value
=1 section
=$1
796 file=/p
/c
/subdir_files
/.mozilla
/firefox
/profiles.ini
797 sed -ri "/^ *$key/d" "$file"
798 sed -ri "/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d};/ *\[$section\]/a $key=$value" "$file"
800 fdhome
() { #firefox default home profile
801 firefox-default-profile Profile0
805 firefox-default-profile Profile4
809 if type -P firefox
&>/dev
/null
; then
817 firefox
-P alt
"$@" >/dev
/null
2>&1
823 local dname
="${PWD##*/}"
824 local m
="/a/tmp/$dname-missing"
825 local d
="/a/tmp/$dname-diff"
826 [[ -e $d ]] && rm "$d"
827 [[ -e $m ]] && rm "$m"
830 while read -r line
; do
832 if [[ -e "$fsfile" ]]; then
833 md5diff
"$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
839 done < <(find .
-type f
)
842 (( msize
<= 100 )) && cat $m
846 # expected output, with different tmp dirs
847 # /tmp/tmp.HDPbwMqdC9/c/d ./c/d
848 # /a/tmp/tmp.qLDkYxBYPM-missing
858 echo different
> $x/c
/d
863 # test whether missing files were renamed, generally for use with fsdiff
864 # $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
865 # echos non-renamed files
869 { sums
+=( "$(md5sum < "$x")" ) ; } 2>/dev
/null
871 while read -r line
; do
872 { missing_sum
=$
(md5sum < "$line") ; } 2>/dev
/null
874 for x
in "${sums[@]}"; do
875 if [[ $missing_sum == "$x" ]]; then
880 $renamed ||
echo "$line"
886 # F = fullscren, z = random, Z = auto zoom
887 command feh
-FzZ "$@"
893 firefox
-P default
"$@" >/dev
/null
2>&1
897 git config user.email ian@iankelling.org
900 # at least in flidas, things rely on gpg being gpg1
902 if type -P gpg2
&>/dev
/null
; then
910 local email
=ian@iankelling.org
911 git send-email
--notes "--envelope-sender=<$email>" \
912 --suppress-cc=self
"$@"
915 gup
() { /a
/f
/gnulib
/build-aux
/gnupload
"$@"; }
917 dejagnu
() { /a
/opt
/dejagnu
/dejagnu
"$@"; }
920 # do git status on published repos.
923 cd $
(readlink
-f $x)/..
924 status
=$
(i status
-s) ||
pwd
925 if [[ $status ]]; then
928 printf "%s\n" "$status"
938 for (( i
=0; i
<60; i
++ )); do
939 day
=$
( date +%F
-d @$
((now
- 86400*i
)) )
940 date "+%a %b %d" -d @$
((now
- 86400*i
)) |
tr '\n' ' '
941 /a
/opt
/timetrap
/bin
/t d
-ftotal -s $day -e $day all
-m '^w|lunch$'
944 to
() { t out
-a "$@"; }
945 ti
() { t
in -a "$@"; }
950 m t out
-a $
(date +%F.
%T
-d @$
(( $
(date -d "$(echo $*|sed 's/[_.]/ /g')" +%s
) + 60*45 )) )
954 arbttlog
() { arbtt-dump
"$@" |
grep -v '( )\|Current Desktop' |
sed -rn '/^[^ ]/{N;s/^(.{21})([0-9]*)[0-9]{3}m.*\(\*/\1\2/;s/^(.{21})[0-9]*.*\(\*/\1/;s/\n//;p}' ; }
957 /a
/opt
/idea-IC-163.7743
.44/bin
/idea.sh
"$@" &r
961 ssh root@iankelling.org
"cd /var/lib/znc/moddata/log/iank/freenode/ && hr && for x in \#$1/*; do base=\${x##*/}; files=(); for f in $@; do tmp=\#\$f/\$base; if [[ -e \$tmp ]]; then files+=(\#\$f/\$base); fi; done; sed \"s/^./\${base%log}/\" \${files[@]}|sort -n; hr; done"
966 # use * instead of -r since that does sorted order
967 ssh root@iankelling.org
"for n in freenode libera; do cd /var/lib/znc/moddata/log/iank/\$n/$chan && hr && for x in *; do echo \$x; sed \"s/^./\${x%log}/\" \$x; hr; done; done" |
less +G
971 if type gio
&> /dev
/null
; then
973 elif type gvfs-open
&> /dev
/null
; then
978 # another alternative is run-mailcap
983 # grep -Evi -e "^(\S+\s+){4}(sudo|sshd|cron)\[\S*:" \
984 # -e "^(\S+\s+){4}systemd\[\S*: (starting|started) (btrfsmaintstop|dynamicipupdate|spamd dns bug fix cronjob|rss2email)\.*$"
987 # journalctl -n 10000 -f "$@" | jfilter
989 # jr() { journalctl "$@" | jfilter | less ; }
990 # jrf() { journalctl -n 200 -f "$@" | jfilter; }
992 jr
() { journalctl
"$@" ; }
993 jrf
() { journalctl
-n 200 -f "$@" ; }
996 ccomp journalctl jtail jr jrf
998 kff
() { # keyboardio firmware flash
999 pushd /a
/bin
/distro-setup
/Arduino
/Model01-Firmware
1000 yes $
'\n' |
make flash
1005 local umask_orig name
1006 if (( $# != 1 )); then
1007 e expected
1 arg
>&2
1013 wg genkey |
tee $name-priv.key | wg pubkey
> $name-pub.key
1017 if (( $# != 2 )); then
1018 e expected
2 arg of hostname
, ip suffix
>&2
1021 local host ipsuf umask_orig
1024 mkdir
-p /p
/c
/machine_specific
/$host/filesystem
/etc
/wireguard
1025 cd /p
/c
/machine_specific
/$host/filesystem
/etc
/wireguard
1028 wg genkey |
tee hole-priv.key | wg pubkey
> hole-pub.key
1029 cat >wghole.conf
<<EOF
1031 # contents hole-priv.key
1032 PrivateKey = $(cat hole-priv.key)
1034 Address = 10.8.0.$ipsuf/24
1035 # https://dev.to/tangramvision/what-they-don-t-tell-you-about-setting-up-a-wireguard-vpn-1h2g
1036 # ||: makes the systemd service not fail due to the failed command
1037 PostUp = ping -c1 10.8.0.1 ||:
1041 PublicKey = zePGl7LoS3iv6ziTI/k8BMh4L3iL3K2t9xJheMR4hQA=
1042 AllowedIPs = 10.8.0.0/24
1043 Endpoint = 72.14.176.105:1194
1044 PersistentKeepalive = 25
1047 # old approach. systemd seems to work fine and cleaner.
1048 rm -f ..
/network
/interfaces.d
/wghole
1049 cedit
-q $host /p
/c
/machine_specific
/li
/filesystem
/etc
/wireguard
/wghole.conf
<<EOF || [[ $? == 1 ]]
1051 PublicKey = $(cat hole-pub.key)
1052 AllowedIPs = 10.8.0.$ipsuf/32
1060 if [[ $1 == /* ]]; then
1062 if mountpoint
/mnt
/$base; then
1065 l
=$
(sudo losetup
-f)
1067 if ! sudo cryptsetup luksOpen
$l $base; then
1071 sudo mkdir
-p /mnt
/$base
1072 sudo mount
/dev
/mapper
/$base /mnt
/$base
1073 sudo chown
$USER:$USER /mnt
/$base
1076 if mountpoint
/mnt
/$base &>/dev
/null
; then
1077 sudo umount
/mnt
/$base
1079 l
=$
(sudo cryptsetup status
/dev
/mapper
/$base|
sed -rn 's/^\s*device:\s*(.*)/\1/p')
1080 sudo cryptsetup luksClose
/dev
/mapper
/$base ||
return 1
1085 # mu personality. for original, just run mp. for 2, run mp 2.
1086 # this is partly duplicated in mail-setup
1090 if ! killall mu
; then
1097 echo error
: mu not dead
1102 set -- /m
/mucache ~
/.cache
/mu
/m
/.mu ~
/.config
/mu
1107 if [[ -e $f && ! -L $f ]]; then
1110 m
ln -sf -T $target $f
1114 # these might need a mu index or something added.
1119 [[ -e $src ]] ||
{ echo "src:$src does not exist"; return 1; }
1121 m
ln -s -T $dst $src
1129 if [[ ! -e $src ||
-L $src ]]; then
1132 [[ -e $src ]] ||
{ echo "src:$src does not exist"; return 1; }
1134 m
ln -sf -T $dst $link
1142 [[ -e $src ]] ||
{ set +x
; return 1; }
1143 if [[ -L $dst ]]; then rm $dst; fi
1150 markdown
"$1" >/tmp
/mdtest.html
1151 firefox
/tmp
/mdtest.html
1154 mo
() { xset dpms force off
; } # monitor off
1157 mpv
--profile=d
"$@";
1160 mpv
--profile=s
"$@";
1168 d
=( /var
/lib
/znc
/moddata
/log
/iank
/{freenode
,libera
} )
1169 # use * instead of -r since that does sorted order
1170 ssh root@iankelling.org
"for f in ${d[@]}; do cd \$f/#$1; grep '\<iank.*' *; done" | cut
--complement -c12-16
1173 c
/p
/c
/.purple
/logs
/jabber
/iank@fsf.org
/office@conference.fsf.org.chat
1174 for x
in *.html
; do html2text
-o ${x%.html}.txt
$x; done;
1175 grep -A1 ') iank:' *.txt |
sed -r 's/^(.{10})[^ ]*\.txt:\(?([^ ]*)[[:space:]](..). iank:/\1_\2_\3/;s/^[^ ]*\.txt-//;/^--$/d;s/^[^ ]*\.txt:\((.{2}).(.{2}).(.{4}) (.{8}) (.{2})\)?/\3-\1-\2_\4_\5/' |
sed -n 'x;1d;0~2{G;s/\n/ /;p};${x;p}'
1179 d
=/var
/lib
/znc
/moddata
/log
/iank
/freenode
1180 ssh root@iankelling.org
"cd $d; find . -mtime -60 -type f -exec grep '\<iank.*' {} +" |
sed -r 's,^..([^/]*)/(.{11})(.{5})(.{8}).,\2\4 \1,' |
sort
1184 local now
time time_sec time_pretty
1186 sqlite3
-separator ' ' /p
/c
/subdir_files
/.local
/share
/gajim
/logs.db
"select time, message from logs where contact_name = 'iank' and jid_id = 17;" |
while read -r time l
; do
1191 if ! time_pretty
=$
(date +%F.
%R
-d @
$time); then
1192 echo bad
time: $time
1195 echo $time_pretty "$l"
1196 time_sec
=${time%%.*}
1197 # only look at the last 18 days. generally just use this for timesheet.
1198 if (( time_sec
< now
- 60 * 60 * 24 * 18 )); then break; fi
1203 sqlite3
-separator ' ' /p
/c
/subdir_files
/.local
/share
/gajim
/logs.db
"select time, message from logs" |
less
1207 e
"lspci -nnk|gr -iA2 net"
1208 lspci
-nnk|gr
-iA2 net
1210 e
"s lshw -C network"
1212 sudo lshw
-C network
1216 ser stop NetworkManager
1217 ser disable NetworkManager
1218 ser stop NetworkManager-wait-online.service
1219 ser disable NetworkManager-wait-online.service
1221 sudo resolvconf
-d NetworkManager
1227 ser start NetworkManager
1233 oathtool
--totp -b "$*" | xclip
-selection clipboard
1238 # from http://askubuntu.com/questions/456021/remove-vocals-from-mp3-and-get-only-instrumentals
1239 pactl load-module module-ladspa-sink sink_name
=Karaoke master
=alsa_output.usb-Audioengine_Audioengine_D1-00.analog-stereo plugin
=karaoke_1409 label
=karaoke control
=-30
1242 pfind
() { #find *$1* in $PATH
1243 [[ $# != 1 ]] && { echo requires
1 argument
; return 1; }
1245 IFS
=: pathArray
=($PATH); unset IFS
1246 find "${pathArray[@]}" -iname "*$1*"
1250 # trash-restore lists everything that has been trashed at or below CWD
1251 # This picks out files just in CWD, not subdirectories,
1252 # which also match grep $1, usually use $1 for a time string
1253 # which you get from running restore-trash once first
1256 # last condition is to not ask again for ones we skipped
1257 while name
="$( echo | restore-trash | gr "$PWD/[^
/]\
+$
" | gr "$1" )" \
1258 && [[ $name ]] && (( $
(wc -l <<<"$name") >= nth
)); do
1259 name
="$(echo "$name" | head -n $nth | tail -n 1 )"
1260 read -r -p "$name [Y/n] " ask
1261 if [[ ! $ask ||
$ask == [Yy
] ]]; then
1262 x
=$
( echo "$name" | gr
-o "^\s*[0-9]*" )
1263 echo $x | restore-trash
> /dev
/null
1264 elif [[ $ask == [Nn
] ]]; then
1274 rld
/a
/h
/_site
/ li
:/var
/www
/iankelling.org
/html
1279 # fixes the menu bar in xmonad. this won\'t be needed when xmonad
1280 # packages catches up on some changes in future (this is written in
1283 # geekosaur: so youll want to upgrade to xmonad 0.13 or else use a
1284 # locally modified XMonad.Hooks.ManageDocks that doesnt set the
1285 # work area; turns out it\'s impossible to set correctly if you are
1286 # not a fully EWMH compliant desktop environment
1288 # geekosaur: chrome shows one failure mode, qt/kde another, other
1289 # gtk apps a third, ... I came up with a setting that works for me
1290 # locally but apparently doesnt work for others, so we joined the
1291 # other tiling window managers in giving up on setting it at all
1293 xprop
-root -remove _NET_WORKAREA
1297 # reviewboard, used at my old job
1298 #rbpipe() { rbt post -o --diff-filename=- "$@"; }
1299 #rbp() { rbt post -o "$@"; }
1307 # only run on MAIL_HOST. simpler to keep this on one system.
1308 r2eadd
() { # usage: name url
1309 # initial setup of rss2email:
1310 # r2e new r2e@iankelling.org
1311 # that initializes files, and sets default email.
1312 # symlink to the config doesnt work, so I copied it to /p/c
1313 # and then use cli option to specify explicit path.
1314 # Only option changed from default config is to set
1317 # or else for a few feeds, the from address is set by the feed, and
1318 # if I fail delivery, then I send a bounce message to that from
1319 # address, which makes me be a spammer.
1321 r2e add
$1 "$2" $1@r2e.iankelling.org
1322 # get up to date and dont send old entries now:
1323 r2e run
--no-send $1
1325 r2e
() { command r2e
-d /p
/c
/rss2email.json
-c /p
/c
/rss2email.cfg
"$@"; }
1327 rspicy
() { # usage: HOST DOMAIN
1328 # connect to spice vm remote host. use vspicy for local host
1330 # shellcheck disable=SC2087
1332 sudo virsh dumpxml $2|grep "<graphics.*type='spice'" | \
1333 sed -rn "s/.*port='([0-9]+).*/\1/p"
1336 if [[ $port ]]; then
1337 spicy
-h $1 -p $port
1339 echo "error: no port found. check that the domain is running."
1345 # s gem install scss-lint
1346 pushd /a
/opt
/thoughtbot-guides
1349 scss-lint
-c /a
/opt
/thoughtbot-guides
/style
/sass
/.scss-lint.yml
"$@"
1353 sk
-e 2120,245 /b
/ds
/brc
/b
/ds
/brc2
1358 out
=${2:-${1%.*}.sh}
1360 script -t -c "mpv --no-config --no-resume-playback --no-terminal --no-audio-display '$1'" $tmp/typescript
2>$tmp/timing
1361 # todo, the current sleep seems pretty good, but it
1362 # would be nice to have an empirical measurement, or
1363 # some better wait to sync up.
1365 # note: --loop-file=no prevents it from hanging if you have that
1366 # set to inf the mpv config.
1367 # --loop=no prevents it from exit code 3 due to stdin if you
1368 # had it set to inf in mpv config.
1370 # args go to mpv, for example --volume=80, 50%
1371 cat >$out <<EOFOUTER
1373 trap "trap - TERM && kill 0" INT TERM ERR; set -e
1374 ( sleep .2; scriptreplay <( cat <<'EOF'
1378 $(cat $tmp/typescript)
1381 base64 -d - <<'EOF'| mpv --loop=no --loop-file=no --no-terminal --no-audio-display "\$@" -
1390 smeld
() { # ssh meld usage host1 host2 file
1391 meld
<(ssh $1 cat $3) <(ssh $2 cat $3)
1395 PATH
=/usr
/local
/spdhackfix
:$PATH command spd
"$@"
1399 sudo systemctl
suspend
1402 spamf
() { # spamtest on FILE
1403 local spamcpre spamdpid
1405 if (( $# != 1 )); then
1406 e spamtest error
: expected
1 arg
, filename
>&2
1410 spamdpid
=$
(systemctl status spamassassin|
sed -n '/^ *Main PID:/s/[^0-9]//gp')
1411 spamcpre
="nsenter -t $spamdpid -n -m"
1412 s
$spamcpre sudo
-u Debian-exim spamassassin
-t --cf='score PYZOR_CHECK 0' <"$1"
1418 declare -gi _seq
; _seq
+=1
1419 echo "test body" | m
mail -s "test mail from $HOSTNAME, $_seq" "${@:-root@localhost}"
1420 # for testing to send from an external address, you can do for example
1421 # -fian@iank.bid -aFrom:ian@iank.bid web-6fnbs@mail-tester.com
1422 # note in exim, you can retry a deferred message
1424 # MSG_ID is in /var/log/exim4/mainlog, looks like 1ccdnD-0001nh-EN
1427 # to test sieve, use below command. for fsf mail, see offlineimap-sync script
1428 # make modifications, then copy to live file, use -eW to actually modify mailbox
1430 # Another option is to use sieve-test SCRIPT MAIL_FILE. note,
1431 # sieve-test doesnt know about envelopes, Im not sure if sieve-filter does.
1433 # sieve with output filter. arg is mailbox, like INBOX.
1434 # This depends on dovecot conf, notably mail_location in /etc/dovecot/conf.d/10-mail.conf
1436 # always run this first, edit the test files, then run the following
1438 sieve-filter ~
/sieve
/maintest.sieve
${1:-INBOX} delete
2> >(head; tail) >/tmp
/testsieve.log
&& sed -rn '/^Performed actions:/,/^[^ ]/{/^ /p}' /tmp
/testsieve.log |
sort |
uniq -c
1442 c ~
/sieve
; cp personal
{test,}.sieve
; cp lists
{test,}.sieve
; cp personalend
{test,}.sieve
1443 sieve-filter
-eWv ~
/sieve
/maintest.sieve
${1:-INBOX} delete
&> /tmp
/testsieve.log
1444 sed -r '/^info: filtering:/{h;d};/^info: msgid=$/N;/^info: msgid=.*left message in mailbox [^ ]+$/d;/^info: msgid=/{H;g};/^info: message kept in source mailbox.$/d' /tmp
/testsieve.log
1449 # testmail above calls sendmail, which is a link to exim/postfix.
1450 # its docs dont say a way of adding an argument
1451 # to sendmail to turn on debug output. We could make a wrapper, but
1452 # that is a pain. Exim debug args are documented here:
1453 # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-the_exim_command_line.html
1455 # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-building_and_installing_exim.html
1456 # note, for exim daemon, you can turn on debug options by
1457 # adding -d, etc to COMMONOPTIONS in
1458 # /etc/default/exim4
1460 # to specify recipients other than those in to, cc, bcc, you can use the cli args, eg:
1461 # exim -t 'test@zroe.org, t2@zroe.org' <<'EOF'
1463 # -t = get recipient from header
1465 From: i@dmarctest.b8.nz
1466 To: mailman@dev.fsf.org
1468 Reply-to: rtest@iankelling.org
1470 This is a test message.
1477 # https://askubuntu.com/questions/160945/is-there-a-way-to-disable-a-laptops-internal-keyboard
1478 id
=$
(xinput
--list --id-only 'AT Translated Set 2 keyboard')
1479 if xinput list |
grep -F '∼ AT Translated Set 2 keyboard' &>/dev
/null
; then
1480 echo enabling keyboard
1481 # find the first slave keyboard number, they are all the same in my output.
1482 # if they werent, worst case we would need to save the slave number somewhere
1483 # when it got disabled.
1484 slave
=$
(xinput list |
sed -n 's/.*slave \+keyboard (\([0-9]*\)).*/\1/p' |
head -n1)
1485 xinput reattach
$id $slave
1494 (sleep $
(calc
"$* * 60") && mpv
--no-config --volume 50 /a
/bin
/data
/alarm.mp3
) > /dev
/null
2>&1 &
1497 trg
() { transmission-remote-gtk
& r
; }
1499 # example, set global upload limit to 100 kilobytes:
1501 TR_AUTH
=":$(jq -r .profiles[0].password ~/.config/transmission-remote-gtk/config.json)" transmission-remote transmission.lan
-ne "$@"
1508 for (( i
=0; i
< retries
- 1; i
++ )); do
1520 if [[ -e $1 && ! -w $1 ||
! -w $
(dirname "$1") ]]; then
1523 # full path for using in some initial setup steps
1530 ecmd
="/usr/sbin/exim4 -C /etc/exim4/my.conf"
1531 if ip a show veth1-mail
&>/dev
/null
; then
1535 pid
=$
(pgrep
-f "/usr/sbin/exim4 -bd -q30m -C /etc/exim4/my.conf"|h1
)
1536 m s nsenter
-t $pid -n -m $ecmd "$@"
1539 sdnbash
() { # systemd namespace bash
1541 m sudo nsenter
-t $
(systemctl status
$unit |
sed -n '/^ *Main PID:/s/[^0-9]//gp') -n -m sudo
-u $USER -i bash
1545 m sudo nsenter
-t $
(systemctl status mailnn|
sed -n '/^ *Main PID:/s/[^0-9]//gp') -n -m sudo
-u $USER -i bash
1549 m sudo nsenter
-t $
(pgrep
-f "/usr/sbin/openvpn .* --config /etc/openvpn/.*mail.conf") -n -m sudo
-u $USER -i bash
1552 m sudo nsenter
-t $
(pgrep
-f "/usr/sbin/exim4 -bd -q30m -C /etc/exim4/my.conf"|h1
) -n -m sudo
-u $USER -i bash
1556 spamdpid
=$
(systemctl status spamassassin|
sed -n '/^ *Main PID:/s/[^0-9]//gp')
1557 m sudo nsenter
-t $spamdpid -n -m sudo
-u Debian-exim spamassassin
"$@"
1560 m sudo nsenter
-t $
(systemctl status unbound|
sed -n '/^ *Main PID:/s/[^0-9]//gp') -n -m sudo
-u $USER -i bash
1565 for p
in mailnn mailvpn unbound dovecot spamassassin exim4 radicale
; do
1566 pid
=$
(s systemctl status
$p|
sed -n '/^ *Main PID:/s/[^0-9]//gp')
1567 if [[ ! $pid ]]; then
1568 echo failed to
find pid
for $p
1571 if ! ns
=$
(s readlink
/proc
/$pid/ns
/net
); then
1572 echo failed to
find ns
for $p pid
=$pid
1575 if [[ $mailnn ]]; then
1576 if [[ $ns != "$mailnn" ]]; then
1577 echo "$p ns $ns != $mailnn"
1588 m sudo
-E env
"PATH=$PATH" nsenter
-t $
(pgrep
-f "/usr/sbin/openvpn .* --config /etc/openvpn/.*client.conf") -n -m "$@"
1591 vpncmd sudo
-E -u iank env
"PATH=$PATH" abrowser
-no-remote -P vpn
& r
1594 vpncmd sudo
-u iank env
"PATH=$PATH" abrowser
-no-remote -P vpn2
& r
1598 vpncmd sudo
-u iank env
"PATH=$PATH" "$@"
1606 if [[ -e /lib
/systemd
/system
/openvpn-client@.service
]]; then
1607 local vpn_service
=openvpn-client
1609 local vpn_service
=openvpn
1612 [[ $1 ]] ||
{ echo need arg
; return 1; }
1613 journalctl
--unit=$vpn_service@
$1 -f -n0 &
1614 # sometimes the journal doesnt open until after the vpn output
1615 # has happened. hoping this fixes that.
1617 sudo systemctl start
$vpn_service@
$1
1618 # sometimes the ask-password agent does not work and needs a delay.
1620 # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=779240
1621 # noticed around 8-2017 after update from around stretch release
1622 # on debian testing, even though the bug is much older.
1623 sudo systemd-tty-ask-password-agent
1626 # systemctl is-enabled / status / cat says nothing, instead theres
1627 # some obscure symlink. paths copied from man systemd.unit.
1628 # possibly also usefull, but incomplete, doesnt show units not loaded in memory:
1629 # seru list-dependencies --reverse --all UNIT
1632 local -a dirs search
1638 ~
/.config
/systemd
/user.control
/*
1639 $XDG_RUNTIME_DIR/systemd
/user.control
/*
1640 $XDG_RUNTIME_DIR/systemd
/transient
/*
1641 $XDG_RUNTIME_DIR/systemd
/generator.early
/*
1642 ~
/.config
/systemd
/user
/*
1644 $XDG_RUNTIME_DIR/systemd
/user
/*
1646 $XDG_RUNTIME_DIR/systemd
/generator
/*
1647 ~
/.local
/share
/systemd
/user
/*
1648 /usr
/lib
/systemd
/user
/*
1649 $XDG_RUNTIME_DIR/systemd
/generator.late
/*
1654 /etc
/systemd
/system.control
/*
1655 /run
/systemd
/system.control
/*
1656 /run
/systemd
/transient
/*
1657 /run
/systemd
/generator.early
/*
1658 /etc
/systemd
/system
/*
1659 /etc
/systemd
/systemd.attached
/*
1660 /run
/systemd
/system
/*
1661 /run
/systemd
/systemd.attached
/*
1662 /run
/systemd
/generator
/*
1663 /lib
/systemd
/system
/*
1664 /run
/systemd
/generator.late
/*
1668 for f
in "${search[@]}"; do
1669 [[ -d $f ]] ||
continue
1676 # dirs is just so we write out the directory names, ls does it when there is 2 or more dirs.
1692 read _ link _ istls
< <(resolvectl dnsovertls tunfsf
)
1695 *) echo fixvpndns error
: unexpected istls value
: $istls >&2; return 1 ;;
1697 s busctl call org.freedesktop.resolve1
/org
/freedesktop
/resolve1 org.freedesktop.resolve1.Manager SetLinkDNSOverTLS is
$link no
1701 [[ $1 ]] ||
{ echo need arg
; return 1; }
1702 if [[ -e /lib
/systemd
/system
/openvpn-client@.service
]]; then
1703 local vpn_service
=openvpn-client
1705 local vpn_service
=openvpn
1707 sudo systemctl stop
$vpn_service@
$1
1709 vpnoffc
() { # vpn off client
1710 ser stop openvpn-client-tr@client
1713 ser start openvpn-client-tr@client
1717 vspicy
() { # usage: VIRSH_DOMAIN
1718 # connect to vms made with virt-install
1719 spicy
-p $
(sudo virsh dumpxml
"$1"|
grep "<graphics.*type='spice'"|\
1720 sed -r "s/.*port='([0-9]+).*/\1/")
1724 cat-new-files
/m
/4e
/INBOX
/new
1727 wtr
() { curl wttr.in
/boston
; }
1729 xevkb
() { xev
-event keyboard
; }
1734 printf "running: %s\n" "$*"
1738 f
=/a
/f
/ansible-configs
/files
/common
/etc
/fsf-workstation-bashrc.sh
1739 if [[ -e $f ]]; then
1740 # shellcheck disable=SC1090
1748 # we also have a file in /a/c/...konsole...
1749 local f
=$HOME/.config
/konsolerc
1750 setini DefaultProfile profileian.profile
"Desktop Entry" $f
1751 setini Favorites profileian.profile
"Favorite Profiles" $f
1752 setini ShowMenuBarByDefault false KonsoleWindow
$f
1753 setini TabBarPosition Top TabBar
$f
1757 while read -r k v
; do
1758 # shellcheck disable=SC2154
1759 setini
$k $v sakura
/a
/c
/subdir_files
/.config
/sakura
/sakura.conf
1761 colorset1_back rgb(33,37,39)
1765 disable_numbered_tabswitch true
1766 scroll_lines 10000000
1771 reset-xscreensaver
() {
1772 # except for spash, i set these by setting gui options in
1773 # xscreensaver-command -demo
1774 # then finding the corresponding option in .xscreensaver
1775 # spash, i happened to notice in .xscreensaver
1777 # dpmsOff, monitor doesnt come back on using old free software supported nvidia card
1778 cat > /home
/iank
/.xscreensaver
<<'EOF'
1781 dpmsStandby: 0:07:00
1782 dpmsSuspend: 0:08:00
1786 lockTimeout: 0:06:00
1793 # * stuff that makes sense to be at the end
1794 if [[ "$SUDOD" ]]; then
1795 # allow failure, for example if we are sudoing into a user with diffferent/lesser permissions.
1798 elif [[ -d /a
]] && [[ $PWD == "$HOME" ]] && [[ $
- == *i
* ]]; then
1805 # for mitmproxy to get a newer python.
1806 # commented until i want to use it because it
1807 # noticably slows bash startup
1811 if [[ $EUID == 0 ||
! -e ~
/.pyenv
/bin
]]; then
1812 echo "error: dont be root. make sure pyenv is installed"
1815 export PATH
="$HOME/.pyenv/bin:$PATH"
1816 eval "$(pyenv init -)"
1817 eval "$(pyenv virtualenv-init -)"
1821 export GOPATH
=$HOME/go
1822 path-add
$GOPATH/bin
1823 path-add
/usr
/local
/go
/bin
1825 # I have the git repo and a release. either one should work.
1826 # I have both because I was trying to solve an issue that
1827 # turned out to be unrelated.
1828 # ARDUINO_PATH=/a/opt/Arduino/build/linux/work
1829 export ARDUINO_PATH
=/a
/opt
/arduino-1.8
.15
1830 export KALEIDOSCOPE_DIR
=/a
/opt
/Kaleidoscope
1832 # They want to be added to the start, but i think
1833 # that should be avoided unless we really need it.
1834 path-add
--end ~
/.npm-global
1837 path-add
--end $HOME/.cargo
/bin
1839 if type -P rg
&>/dev
/null
; then
1840 # --no-messages because of annoying errors on broken symlinks
1841 rg
() { command rg
--no-messages -L -i -M 300 --no-ignore "$@" ||
return $?
; }
1842 #fails if not exist. ignore
1843 complete
-r rg
2>/dev
/null ||
:
1850 # taken from default changes to bashrc and bash_profile
1851 path-add
--end --ifexists $HOME/.rvm
/bin
1852 # also had ruby bin dir, but moved that to environment.sh
1853 # so its included in overall env
1856 export BASEFILE_DIR
=/a
/bin
/fai-basefiles
1858 #export ANDROID_HOME=/a/opt/android-home
1859 # https://f-droid.org/en/docs/Installing_the_Server_and_Repo_Tools/
1860 #export USE_SDK_WRAPPER=yes
1861 #PATH=$PATH:$ANDROID_HOME/tools:$ANDROID_HOME/platform-tools
1863 # didnt get drush working, if I did, this seems like the
1864 # only good thing to include for it.
1865 # Include Drush completion.
1866 # if [ -f "/home/ian/.drush/drush.complete.sh" ] ; then
1867 # source /home/ian/.drush/drush.complete.sh
1874 # https://wiki.archlinux.org/index.php/Xinitrc#Autostart_X_at_login
1875 # i added an extra condition as gentoo xorg guide says depending on
1876 # $DISPLAY is fragile.
1877 if [[ ! $DISPLAY && $XDG_VTNR == 1 ]] && shopt -q login_shell
&& isarch
; then
1882 # ensure no bad programs appending to this file will have an affect